unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, system.UITypes, System.UIConsts;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Image2: TImage;
    Label1: TLabel;
    Image3: TImage;
    Label2: TLabel;
    PaintBtn: TButton;
    Label3: TLabel;
    Label4: TLabel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image2MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image2DblClick(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image1DblClick(Sender: TObject);
    procedure PaintBtnClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    procedure Imageout(Image: TBitmap; magnification: double);
    procedure ColorBar;
    function  PGetColor(X , Y: integer): TAlphaColor;
    procedure PSetColor(X , Y: integer; Color: TAlphaColor);
    procedure Scanline(left_X, right_X, Y: integer; color: TAlphaColor);
    procedure Push(X, Y: integer);
    procedure Pop(var X, Y: integer);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Type
  TAlphaArray = array[0..0] of TAlphaColor;  // TAlphaColor  Cardinal
  PAlphaArray = ^TAlphaArray;

  TPosXY = record                            // obt@W
    X : integer;
    Y : integer;
  end;

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 512;    // \gTCY

  ADDSIZE = 50;        // Buff TCYZl

var
  InputDBitmap    : TBitmap;                    // ̓f[^[\prbg}bv
  GHeight         : Integer;                    // ̓f[^[摜
  GWidth          : Integer;                    // ̓f[^[摜
  MGHeight        : Integer;                    // ̓f[^[摜
  MGWidth         : Integer;                    // ̓f[^[摜

  VRect           : Trect;                      // \TCYݒp
  InFilename      : string;                     // ̓t@C
  Scale           : double;                     // 摜̕\XP[
  DidScale        : double;                     // }EXWvZpW
  PA              : array of PAlphaArray;       // |C^[z
  Xpos, Ypos      : Integer;                    // }EXW
  PaintColor      : TAlphaColor;                // hԂF
  DotColor        : TAlphaColor;                // hԂ_\F
  Buff            : array of TPosXY;            // hԂJn_Wobt@
  EIndex          : integer;                    // obt@CfbNX
  IXpos, IYpos    : Integer;                    // hԂJn_
  OpenF           : Boolean;                    // t@CJꍇ̃tO
  PPSize          : integer;                    // oct@TCY

//--------------------------
// J[o[}
//--------------------------
procedure TForm1.ColorBar;
var
  h   : integer;
  hue : double;
  sat : double;
  lat : double;
  Cor : TAlphaColor;
begin
  sat := ScrollBar1.Position / 100;          // ʓx
  lat := ScrollBar2.Position / 100;          // x
  for h := 0 to 359 do begin
    hue := h / 360;
    Cor := HSLtoRGB(hue, sat, lat);            // x0.5  0.5 F
//    Cor := RGBtoBGR(Cor);
    Image2.Canvas.Pen.Color := Cor and $00FFFFFF;
    Image2.Canvas.MoveTo(h, 0);
    Image2.Canvas.LineTo(h, image2.Height);
  end;
  for h := 360 to 369 do begin
    Image2.Canvas.Pen.Color :=  $00FFFFFF;
    Image2.Canvas.MoveTo(h, 0);
    Image2.Canvas.LineTo(h, image2.Height);
  end;
  for h := 370 to 380 do begin
    Image2.Canvas.Pen.Color :=  $00000000;
    Image2.Canvas.MoveTo(h, 0);
    Image2.Canvas.LineTo(h, image2.Height);
  end;
  PaintColor := clBlack;
  DotColor   := clBlack;
end;

//------------------------------
// J[o[ʓx̕ύX
//------------------------------
procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  ColorBar;
end;

//------------------------------
// J[o[x̕ύX
//------------------------------
procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  ColorBar;
end;

//--------------------------------------
// wW̐F̏
//--------------------------------------
procedure TForm1.PSetColor(X , Y: integer; Color: TAlphaColor);
begin
  PA[Y][X] := Color;
end;

//-----------------------------------
// [W̐F̎擾
//-----------------------------------
function TForm1.PGetColor(X , Y: integer): TAlphaColor;
begin
  Result := PA[Y][X] and $00FFFFFF;
end;

//-----------------------------------
// hԂJn_̎w
//-----------------------------------
procedure TForm1.Image1DblClick(Sender: TObject);
var
  X , Y : integer;
begin
  if not OpenF then exit;
  X := Trunc(Xpos * DidScale);
  Y := Trunc(Ypos * DidScale);
  if X < 0 then X := 0;
  if X > MGWidth then X := MGWidth;
  if Y < 0 then Y := 0;
  if Y > MGHeight then Y := MGHeight;
  IXpos := X;
  IYpos := Y;
  Label3.Caption := 'XW ' + intTostr(IXpos);
  Label4.Caption := 'YW ' + intTostr(IYpos);
  PaintBtn.Enabled := True;
  Imageout(InputDBitmap, scale);                              // o͘gɕϔ{o
  image1.Canvas.Brush.Color := DotColor;
  image1.Canvas.Brush.Style := bsSolid;
  image1.Canvas.Pen.Color   := DotColor;
  image1.Canvas.Pen.Style   := psSolid;
  image1.Canvas.Ellipse(Xpos - 5, Ypos - 5, Xpos + 5, Ypos + 5);
end;

//--------------------------------------
// 摜̍W擾
//--------------------------------------
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  Xpos := X;
  Ypos := Y;
end;

//----------------------------------------------------------------
// J[o[F̎擾
// TImage ̎oFTBitmapoFRGB̏Ԃ
// Ⴄ̂ RGBtoBGR@ŕϊ
//----------------------------------------------------------------
procedure TForm1.Image2DblClick(Sender: TObject);
begin
  DotColor := Image2.Canvas.Pixels[Xpos, Ypos] and $00FFFFFF;
  Image3.Canvas.Brush.Color := DotColor;
  Image3.Canvas.FloodFill(15, 15, clYellow, fsBorder);
  // RGB̐F̏ԕύX
  PaintColor := RGBtoBGR(DotColor);
end;

//--------------------------
// J[o[̍W擾
//--------------------------
procedure TForm1.Image2MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  Xpos := X;
  Ypos := Y;
end;

//---------------------------------------------------------------------
// Push Pop DelphiɂȂߒǉ
// 񖈂ɒςƎԂ̂ŁAs蒷ǉ܂
// EIndex@ɑ΂ĔzŌ̈ʒu {EIndex - 1}
//---------------------------------------------------------------------
procedure TForm1.Push(X, Y: integer);
begin
  inc(EIndex);
  // oct@̃TCYsoct@܂
  if PPSize < EIndex then begin
    PPSize := PPSize + ADDSIZE;
    setlength(buff, PPSize);
  end;
  buff[EIndex - 1].X := X;
  buff[EIndex - 1].Y := Y;
end;

procedure TForm1.Pop(var X, Y: integer);
begin
  X := buff[EIndex - 1].X;
  Y := buff[EIndex - 1].Y;
  dec(EIndex);
// oct@̃TCYKvȂȂ̂ŏȗĂ܂
// Paint̊JnTCYɃZbg܂
{
  if PPSize - EIndex > ADDSIZE then begin
    PPSize := PPSize - ADDSIZE;
    setlength(buff, PPSize);
  end;
}
end;

//-----------------------------------------------------
// V[hė̈Fobt@ɓo^܂
// left_X, right_X  XW͈̔
// Y YW
// color ̈F
//-----------------------------------------------------
procedure TForm1.Scanline(left_X, right_X, Y:integer; color: TAlphaColor);
begin
  while left_X <= right_X do begin
    // ̈F ̈F u[N
    while left_X < right_X do begin                 // right_X - 1 ̈ʒu܂Ō
      if PGetColor(left_X, y) = color then Break;   // ̈E猟I
      inc(left_X);
    end;
    // left_X ̈ʒüF擪whileu[Ñ[`
    // OwhileŃu[Nꍇ͗̈FȂ̂Ńu[NȂ
    // OwhileŃu[NȂꍇ(̈FȂꍇ) left_X =@right_X
    if PGetColor(left_X, y) <> color then Break;

    // ̈F ̈F u[N
    while left_X <= right_X do begin
      if PGetColor(left_X, y) <> color then Break;
      inc(left_X);
    end;
    // ͈͂ɗ̈F̂Ńobt@ɗ̈W
    // O While   left_X@CNĝłP}CiX܂
    Push(left_X - 1, Y);
  end;
end;

//---------------------------------------------
// hԂ
// left_X, Right_X JnW
// PaintColor hԂF
// color ̈F
//---------------------------------------------
procedure TForm1.PaintBtnClick(Sender: TObject);
var
  left_X, Right_X : integer;
  Line_Y          : integer;
  I               : integer;
  color           : TAlphaColor;
  MaxI            : integer;
begin
  // ̈F̎擾
  color := PGetColor(IXpos, IYpos);
  // ̈FƓhԂFI
  if color = PaintColor then exit;

  // obt@C_bNX̏ݒ
  MaxI := 0;                        // obt@ől
  EIndex := 0;                      // oct@ʒu
  PPSize := ADDSIZE;                // obt@TCYZbg
  setlength(buff, PPSize);          // obt@TCYm

  // obt@ɊJn_̍WZbg
  push(IXpos, IYpos);

  repeat
    // obt@Wo
    pop(left_X, Line_Y);
    Right_X := left_X;

    // W̐F̎oÄFŖ玟̃oct@
    // ɓhԂĂꍇ
    if PGetColor(left_X, Line_Y) <> color then continue;

    // E̔̈F
    while Right_X < MGWidth do begin
      if PGetColor(Right_X + 1, Line_Y) <> color then break;
      inc(Right_X);
    end;

    // ̔̈F
    while Left_X > 0 do begin
      if PGetColor(left_X - 1, Line_Y) <> color then break;
      dec(left_X);
    end;

    // E܂œhԂ
    for I := Left_X to Right_X do PSetColor(i, Line_Y, PaintColor);

    // ^̃CXL
    if Line_Y + 1 <= MGHeight then scanline(Left_X, Right_X, Line_Y + 1, color);

    // ^̃CXL܂
    if Line_Y - 1 >= 0 then scanline(Left_X, Right_X, Line_Y - 1, color);

    // obt@őgpʕ\
    if MaxI < EIndex then begin
      MAXI := EIndex;
      label7.Caption := 'obt@őgp ' + intTostr(MAXI + 1);
    end;
  // obt@ʒuOɂȂI
  until EIndex = 0;
  // hԂʕ\
  Imageout(InputDBitmap, scale);                              // o͘gɕϔ{o
end;

//------------------------
// 摜f[^[̕ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap; magnification: double);
var
  Rect0           : Trect;
  MW, MH          : Integer;
begin
  MW := Round(GWidth * magnification);
  MH := Round(GHeight * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  Image1.Width := MW;
  Image1.Height := MH;
  Image1.Picture.Bitmap.SetSize(MW, MH);
  Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
end;

//---------------------------
// 摜t@CI[v
//---------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  Y           : Integer;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                   // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        InputDBitmap.Canvas.Draw(0, 0, WIC);                  // rbg}bvɕ`tH[}bgϊ
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  MGHeight := GHeight - 1;                                    // ̓f[^[摜
  MGWidth  := GWidth  - 1;                                    // ̓f[^[摜

  // 摜\XP[ݒ
  scale := ImageHWC / GWidth;
  if scale > ImageHWC / GHeight then scale := ImageHWC / GHeight;
  if scale <> 0 then DidScale := 1 / scale;
  // ͉摜\
  Imageout(InputDBitmap, scale);                              // o͘gɕϔ{o

  // 摜@y |C^z쐬
  setlength(pa , GHeight);
  for Y := 0 to MGHeight do
    PA[Y] := InputDBitmap.ScanLine[Y];

  OpenF := True;
  PaintBtn.Enabled := False;
end;

//------------------------
// ݒ
//------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Width  := ImageHWC;
  Image1.Height := ImageHWC;
  ScrollBox1.Height := ImageHWC + 5;
  ScrollBox1.Width  := ImageHWC + 5;
  Image1.Top := 0;
  Image1.Left := 0;
  InputDBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf32bit;
  Image2.Top := 15;
  Image2.Left := 136;
  Image2.Width := 380;
  Image2.Height := 30;
  Image3.Top := 15;
  Image3.Left := 620;
  Image3.Width := 30;
  Image3.Height := 30;
  Image3.Canvas.Brush.Color := clBlack;
  Image3.Canvas.Brush.Style := bsSolid;
  Image3.Canvas.FloodFill(15, 15, clYellow, fsBorder);
  ColorBar;
  OpenF := False;
  PaintBtn.Enabled := False;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
end;

end.
